﻿namespace Section4_3.Models
{
    using System.Threading;
    using System.Threading.Tasks;

    public class SampleModel
    {
        /// <summary>
        /// 重たい処理を別タスクでおこないます。
        /// </summary>
        /// <returns></returns>
        public Task DoHeavyWorkAsync()
        {
            return Task.Run(() =>
            {
                DoHeavyWorkCore();
            });
        }

        /// <summary>
        /// 重たい処理をおこないます。
        /// </summary>
        private void DoHeavyWorkCore()
        {
            // 仮想的な重たい処理として 10[s] 間待機する
            Thread.Sleep(10000);
        }
    }
}
