﻿namespace Section4_6.ViewModels
{
    using YKToolkit.Bindings;

    public class MainViewModel : NotificationObject
    {
        private string param1 = "Param1";
        /// <summary>
        /// パラメータ 1 を取得または設定します。
        /// </summary>
        public string Param1
        {
            get { return param1; }
            set { SetProperty(ref param1, value); }
        }

        private string param2 = "Param2";
        /// <summary>
        /// パラメータ 2 を取得または設定します。
        /// </summary>
        public string Param2
        {
            get { return param2; }
            set { SetProperty(ref param2, value); }
        }
    }
}
